using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Inventory.TransferOut.Cqrs;

public record DeleteTransferOutByIdCommand(string Id) : IRequest<bool>;

public class DeleteTransferOutByIdHandler : IRequestHandler<DeleteTransferOutByIdCommand, bool>
{
    private readonly AppDbContext _context;
    public DeleteTransferOutByIdHandler(AppDbContext context) => _context = context;

    public async Task<bool> Handle(DeleteTransferOutByIdCommand request, CancellationToken cancellationToken)
    {
        var entity = await _context.TransferOut
            .FirstOrDefaultAsync(x => x.Id == request.Id, cancellationToken);

        if (entity == null) return false;

        var items = await _context.InventoryTransaction
            .Where(x => x.ModuleId == request.Id && x.ModuleName == nameof(Data.Entities.TransferOut))
            .ToListAsync(cancellationToken);

        _context.InventoryTransaction.RemoveRange(items);
        _context.TransferOut.Remove(entity);
        await _context.SaveChangesAsync(cancellationToken);
        return true;
    }
}